Update to sagemath 7.3

This commit is contained in:
pcpa 2016-08-20 13:51:55 -04:00
parent a3d306800c
commit 0fdebf23cf
35 changed files with 3245 additions and 874 deletions

View file

@ -1,12 +1,13 @@
diff -up src/bin/sage.orig src/bin/sage
--- src/bin/sage.orig 2015-11-07 11:53:13.984795336 -0200
+++ src/bin/sage 2015-11-07 11:53:51.199796761 -0200
@@ -13,19 +13,15 @@ usage() {
--- src/bin/sage.orig 2016-08-08 13:05:27.823465130 -0400
+++ src/bin/sage 2016-08-08 13:12:27.114481186 -0400
@@ -13,20 +13,16 @@ usage() {
echo " file.[sage|py|spyx] -- run given .sage, .py or .spyx file"
echo " -advanced -- list all command line options"
echo " -c <cmd> -- Evaluates cmd as sage code"
- echo " -experimental -- list all experimental packages that can be installed"
echo " -gap [...] -- run Sage's Gap with given arguments"
echo " -gap3 [...] -- run Sage's Gap3 with given arguments"
echo " -gp [...] -- run Sage's PARI/GP calculator with given arguments"
echo " -h, -? -- print this help message"
- echo " -i [packages] -- install the given Sage packages"
@ -15,13 +16,13 @@ diff -up src/bin/sage.orig src/bin/sage
echo " -maxima [...] -- run Sage's Maxima with given arguments"
echo " -mwrank [...] -- run Sage's mwrank with given arguments"
echo " --notebook=[...] -- start the Sage notebook (valid options are"
echo " 'default', 'sagenb', and 'ipython')"
echo " 'default', 'sagenb', 'jupyter', and 'export')"
echo " -n, --notebook -- shortcut for --notebook=default"
- echo " -optional -- list all optional packages that can be installed"
echo " -python [...] -- run the Python interpreter"
echo " -R [...] -- run Sage's R with given arguments"
echo " -singular [...] -- run Sage's singular with given arguments"
@@ -41,10 +37,6 @@ usage() {
@@ -42,10 +38,6 @@ usage() {
echo " --optional - controls which optional tests are run"
echo " --sagenb - test all sagenb files"
echo " --help - show all testing options"
@ -32,7 +33,7 @@ diff -up src/bin/sage.orig src/bin/sage
echo " -v, -version -- display Sage version information"
exit 0
}
@@ -63,11 +55,8 @@ usage_advanced() {
@@ -64,11 +56,8 @@ usage_advanced() {
echo " -preparse <file.sage> -- preparse file.sage and produce corresponding file.sage.py"
echo " -q -- quiet; start with no banner"
echo " -root -- print the Sage root directory"
@ -44,8 +45,8 @@ diff -up src/bin/sage.orig src/bin/sage
echo
#### 1.......................26..................................................78
@@ -77,8 +66,6 @@ usage_advanced() {
echo " 'default', 'sagenb', and 'ipython'). See the output"
@@ -78,8 +67,6 @@ usage_advanced() {
echo " 'default', 'sagenb', and 'jupyter'). See the output"
echo " of sage --notebook --help for more details and"
echo " examples of how to pass optional arguments"
- echo " -bn, -build-and-notebook [...] -- build the Sage library then start"
@ -53,7 +54,7 @@ diff -up src/bin/sage.orig src/bin/sage
echo " -inotebook [...] -- start the *insecure* Sage notebook (deprecated)"
echo " -n, -notebook [...] -- start the default Sage notebook (options are the"
echo " same as for the notebook command in Sage). See the"
@@ -96,13 +83,9 @@ usage_advanced() {
@@ -98,12 +85,9 @@ usage_advanced() {
echo " -gp [...] -- run Sage's PARI/GP calculator with given arguments"
echo " -ipython [...] -- run Sage's IPython using the default environment (not"
echo " Sage), passing additional options to IPython"
@ -63,32 +64,35 @@ diff -up src/bin/sage.orig src/bin/sage
echo " -lisp [...] -- run Lisp interpreter included with Sage"
echo " -M2 [...] -- run Sage's Macaulay2 with given arguments"
- command -v M2 &>/dev/null || \
- echo " (not installed currently, run sage -i macaulay2)"
echo " (not installed currently, run sage -i macaulay2)"
echo " -maxima [...] -- run Sage's Maxima with given arguments"
echo " -mwrank [...] -- run Sage's mwrank with given arguments"
echo " -python [...] -- run the Python interpreter"
@@ -116,45 +99,7 @@ usage_advanced() {
@@ -118,49 +102,7 @@ usage_advanced() {
echo
#### 1.......................26..................................................78
#### |.....................--.|...................................................|
- echo "Installing packages and upgrading:"
- echo " -package [args] -- call the new package manager with given arguments."
- echo " Run without arguments for package-specific help."
- echo " -experimental -- list all experimental packages that can be installed"
- echo " -f [opts] [packages]-- shortcut for -i -f: force build of the given Sage"
- echo " packages"
- echo " -i [opts] [packages]-- install the given Sage packages (unless they are"
- echo " already installed); if no packages are given, print"
- echo " a list of all installed packages. Options:"
- echo " -i [opts] [packages]-- install the given Sage packages. Options:"
- echo " -c -- run the packages' test suites"
- echo " -d -- only download, do not install packages"
- echo " -f -- force build: install the packages even"
- echo " if they are already installed"
- echo " -s -- do not delete the spkg/build directories"
- echo " -s -- do not delete the temporary build directories"
- echo " after a successful build"
- echo " -p [opts] [packages]-- install the given Sage packages, without dependency"
- echo " checking and with support for old-style spkgs."
- echo " Options are -c, -d and -s with the same meaning as"
- echo " for the -i command"
- echo " -info [packages] -- print the SPKG.txt of the given packages"
- echo " --location -- if needed, fix paths to make Sage relocatable"
- echo " -optional -- list all optional packages that can be installed"
- echo " -standard -- list all standard packages that can be installed"
- echo " -installed -- list all installed packages"
- #echo " -update -- download latest non-optional Sage packages (do not build them)"
- #echo " -update-build -- build and install all downloaded non-optional Sage packages"
- echo " -upgrade [version] -- download, build and install the given version. Here,"
- echo " 'version' is a git branch or tag name. Useful values"
- echo " are 'master' (the current development version, this"
@ -114,7 +118,7 @@ diff -up src/bin/sage.orig src/bin/sage
echo " -startuptime [module] -- display how long each component of Sage takes to"
echo " start up; optionally specify a module to get more"
echo " details about that particular module"
@@ -184,7 +129,6 @@ usage_advanced() {
@@ -190,7 +132,6 @@ usage_advanced() {
echo " -coverage <files> -- give info about doctest coverage of files"
echo " -coverageall -- give summary info about doctest coverage of all"
echo " files in the Sage library"
@ -122,15 +126,16 @@ diff -up src/bin/sage.orig src/bin/sage
echo " -search_src <string> -- search through all the Sage library code for string"
echo " -search_doc <string> -- search through the Sage documentation for string"
echo " -grep <string> -- same as -search_src"
@@ -204,15 +148,6 @@ usage_advanced() {
@@ -210,16 +151,6 @@ usage_advanced() {
echo
#### 1.......................26..................................................78
#### |.....................--.|...................................................|
- echo "Making Sage packages or distributions:"
- echo " -bdist <tmpdir> -- build a binary distribution of Sage"
- echo " -sdist -- build a source distribution of Sage"
- echo " -pkg <dir> -- create Sage package dir.spkg from a given directory"
- echo " -pkg_nc <dir> -- as -pkg, but do not compress the package"
- echo " -sdist -- build a source distribution of Sage"
- echo " -fix-pkg-checksums -- fix the checksums from build/pkgs directories from "
- echo " the packages located in upstream/"
-
- echo
- #### 1.......................26..................................................78
@ -138,7 +143,7 @@ diff -up src/bin/sage.orig src/bin/sage
echo "Valgrind memory debugging:"
echo " -cachegrind -- run Sage using Valgrind's cachegrind tool. The log"
echo " files are named sage-cachegrind.PID can be found in"
@@ -226,9 +161,6 @@ usage_advanced() {
@@ -233,9 +164,6 @@ usage_advanced() {
echo " -memcheck -- run Sage using Valgrind's memcheck tool. The log"
echo " files are named sage-memcheck.PID can be found in"
echo " $DOT_SAGE"
@ -148,17 +153,7 @@ diff -up src/bin/sage.orig src/bin/sage
echo " -valgrind -- this is an alias for -memcheck"
echo
echo "You can also use -- before a long option, e.g., 'sage --optional'."
@@ -236,9 +168,6 @@ usage_advanced() {
exit 0
}
-# Check for '--nodotsage' before sourcing sage-env; otherwise sage-env
-# will already have set some environment variables with the old
-# setting for DOT_SAGE.
if [ "$1" = '--nodotsage' ]; then
export DOT_SAGE=`mktemp -d ${TMPDIR:-/tmp}/dotsageXXXXXX`
shift
@@ -248,34 +177,6 @@ if [ "$1" = '--nodotsage' ]; then
@@ -260,86 +188,6 @@ if [ "$1" = '--nodotsage' ]; then
exit $status
fi
@ -178,10 +173,63 @@ diff -up src/bin/sage.orig src/bin/sage
- exec local/bin/sage-upgrade "$@"
-fi
-
-# Check for '-i' before sourcing sage-env: running "make"
-# should be run outside of the Sage shell.
-if [ "$1" = '-f' ]; then
- # -f is an alias for -i -f
- set -- -i "$@"
-fi
-
-if [ "$1" = '-i' ]; then
- shift
- if [ -z "$MAKE" ]; then
- MAKE="make"
- fi
-
- set -e
-
- cd "$SAGE_ROOT"
-
- # First of all, make sure that the toolchain is up-to-date
- # (which is a dependency of every package)
- ./sage --location
- $MAKE all-toolchain
- echo
-
- INSTALL_OPTIONS="" # Options to sage-spkg
- for PKG in "$@"
- do
- case "$PKG" in
- -info|--info)
- echo >&2 "Error: 'sage -i $PKG <package>' is no longer supported, use 'sage --info <package>' instead."
- exit 2;;
- -f) FORCE_INSTALL=yes;;
- -*) INSTALL_OPTIONS="$INSTALL_OPTIONS $PKG";;
- *)
- # First check that $PKG is actually a Makefile target
- if ! grep "^$PKG: " build/make/Makefile >/dev/null; then
- echo >&2 "Error: package '$PKG' not found"
- echo >&2 "Assuming it is an old-style package... (this is deprecated: use -p instead of -i to install old-style packages)"
- echo >&2
- sleep 5
- ./sage -p $INSTALL_OPTIONS "$PKG"
- else
- if [ x$FORCE_INSTALL = xyes ]; then
- $MAKE "$PKG-clean"
- fi
- $MAKE SAGE_SPKG="sage-spkg $INSTALL_OPTIONS" "$PKG"
- fi;;
- esac
- done
- exit 0
-fi
-
-
-#####################################################################
-# Source sage-env ($0 is the name of this "sage" script, so we can just
-# append -env to that). We redirect stdout to stderr, which is safer
-# for scripts.
-#####################################################################
-. "$0-env" >&2
-if [ $? -ne 0 ]; then
- echo >&2 "Error setting environment variables by sourcing '$0-env';"
@ -189,11 +237,10 @@ diff -up src/bin/sage.orig src/bin/sage
- exit 1
-fi
-
-
if [ $# -gt 0 ]; then
if [ "$1" = '-h' -o "$1" = '-?' -o "$1" = '-help' -o "$1" = '--help' ]; then
usage
@@ -287,25 +188,11 @@ fi
@@ -352,26 +200,12 @@ fi
# Prepare for running Sage, either interactively or non-interactively.
sage_setup() {
@ -209,9 +256,10 @@ diff -up src/bin/sage.orig src/bin/sage
- exit 1
- fi
-
# Display the startup banner
# Display the startup banner (unless SAGE_BANNER is explictly "no")
if [ "$SAGE_BANNER" != "no" ]; then
cat "$SAGE_LOCAL/bin/sage-banner"
# can be 'bare', or 'yes', or unspecified
echo "$SAGE_BANNER_TEXT"
fi
- maybe_sage_location
@ -219,7 +267,7 @@ diff -up src/bin/sage.orig src/bin/sage
if [ ! -d "$IPYTHONDIR" ]; then
# make sure that $DOT_SAGE exists so that ipython will happily
# create its config directories there. If DOT_SAGE doesn't
@@ -316,20 +203,6 @@ sage_setup() {
@@ -382,20 +216,6 @@ sage_setup() {
}
@ -240,7 +288,7 @@ diff -up src/bin/sage.orig src/bin/sage
# Start an interactive Sage session, this function never returns.
interactive_sage() {
sage_setup
@@ -396,7 +269,7 @@ fi
@@ -467,7 +287,7 @@ fi
if [ "$1" = '-singular' -o "$1" = '--singular' ]; then
shift
@ -249,7 +297,7 @@ diff -up src/bin/sage.orig src/bin/sage
fi
if [ "$1" = '-sqlite3' -o "$1" = '--sqlite3' ]; then
@@ -424,16 +297,6 @@ if [ "$1" = '-lisp' -o "$1" = '--lisp' ]
@@ -495,16 +315,6 @@ if [ "$1" = '-lisp' -o "$1" = '--lisp' ]
exec ecl "$@"
fi
@ -266,15 +314,22 @@ diff -up src/bin/sage.orig src/bin/sage
if [ "$1" = '-maxima' -o "$1" = '--maxima' ]; then
shift
exec maxima "$@"
@@ -474,16 +337,6 @@ if [ "$1" = '-ipython' -o "$1" = '--ipyt
exec ipython "$@"
@@ -530,11 +340,6 @@ if [ "$1" = '-pip' -o "$1" = '--pip' ];
exec pip "$@"
fi
-if [ "$1" = '-git' -o "$1" = '--git' ]; then
-if [ "$1" = '-fix-pkg-checksums' -o "$1" = '--fix-pkg-checksums' ]; then
- shift
- exec git "$@"
- exec sage-fix-pkg-checksums "$@"
-fi
-
if [ "$1" = '-python' -o "$1" = '--python' ]; then
shift
exec python "$@"
@@ -555,11 +360,6 @@ if [ "$1" = '-git' -o "$1" = '--git' ];
exec git "$@"
fi
-if [ "$1" = '-git-branch' -o "$1" = '--git-branch' ]; then
- shift
- exec git --git-dir="$SAGE_ROOT"/.git rev-parse --abbrev-ref HEAD
@ -283,7 +338,7 @@ diff -up src/bin/sage.orig src/bin/sage
if [ "$1" = '-sh' -o "$1" = '--sh' ]; then
# AUTHORS:
# - Carl Witty and William Stein: initial version
@@ -603,20 +456,6 @@ EOF
@@ -679,20 +479,6 @@ EOF
fi
#####################################################################
@ -304,7 +359,7 @@ diff -up src/bin/sage.orig src/bin/sage
# File conversion
#####################################################################
@@ -634,11 +473,6 @@ fi
@@ -710,11 +496,6 @@ fi
# Run Sage's versions of the standard Algebra/Geometry etc. software
#####################################################################
@ -316,7 +371,7 @@ diff -up src/bin/sage.orig src/bin/sage
if [[ "$1" =~ ^--notebook=.* || "$1" =~ ^-n=.* || "$1" =~ ^-notebook=.* ]] ; then
sage-cleaner &>/dev/null &
exec sage-notebook "$@"
@@ -649,13 +483,6 @@ if [ "$1" = "-notebook" -o "$1" = '--not
@@ -725,13 +506,6 @@ if [ "$1" = "-notebook" -o "$1" = '--not
exec sage-notebook "$@"
fi
@ -330,7 +385,7 @@ diff -up src/bin/sage.orig src/bin/sage
if [ "$1" = "-inotebook" -o "$1" = '--inotebook' ]; then
shift
sage-cleaner &>/dev/null &
@@ -674,31 +501,12 @@ if [ "$1" = '-grepdoc' -o "$1" = "--grep
@@ -750,38 +524,19 @@ if [ "$1" = '-grepdoc' -o "$1" = "--grep
exit 0
fi
@ -363,7 +418,15 @@ diff -up src/bin/sage.orig src/bin/sage
if [ ! -f "$DOT_SAGE"/init.sage ]; then
echo >&2 "init.sage does not exist ... creating"
touch "$DOT_SAGE"/init.sage
@@ -715,17 +523,6 @@ if [ "$1" = '-t' -o "$1" = '-bt' -o "$1"
fi
SAGE_BANNER=no sage_setup
export PYTHONIOENCODING="utf-8" # Fix encoding for doctests
- if [ "$1" = '-tp' -o "$1" = '-btp' ]; then
+ if [ "$1" = '-tp' ]; then
shift
exec sage-runtests -p "$@"
else
@@ -790,16 +545,6 @@ if [ "$1" = '-t' -o "$1" = '-bt' -o "$1"
fi
fi
@ -372,52 +435,41 @@ diff -up src/bin/sage.orig src/bin/sage
- build_sage
- fi
- shift
- SAGE_BANNER="no"
- sage_setup
- SAGE_BANNER=no sage_setup
- export PYTHONIOENCODING="utf-8" # Fix encoding for doctests
- exec sage-runtests --new "$@"
-fi
-
if [ "$1" = '-testall' -o "$1" = "--testall" ]; then
shift
SAGE_BANNER="no"
@@ -742,140 +539,6 @@ if [ "$1" = '-c' ]; then
SAGE_BANNER=no sage_setup
@@ -814,133 +559,6 @@ if [ "$1" = '-c' ]; then
exec sage-eval "$@"
fi
-if [ "$1" = '--location' ]; then
- maybe_sage_location
- exit 0
-fi
-
-
-install() {
- maybe_sage_location
-
- mkdir -p "$SAGE_LOGS"
- for PKG in "$@"
- do
- # Check for options
- case "$PKG" in
- -f) OPTF="-f"
- -*)
- INSTALL_OPTIONS="$INSTALL_OPTIONS $PKG"
- continue;;
- -m) OPTS="-s"
- echo >&2 "Warning: the -m option is deprecated since Sage 5.0. Use -s instead."
- continue;;
- -s) OPTS="-s"
- continue;;
- -c) OPTC="-c"
- continue;;
- --check) OPTC="-c"
- continue;;
- -info) OPTINFO="--info"
- continue;;
- --info) OPTINFO="--info"
- continue;;
- -*) echo >&2 "Error: unknown option '$PKG'"
- exit 2;;
- esac
-
- PKG_NAME=`echo "$PKG" | sed -e "s/\.spkg$//"`
- PKG_NAME=`basename "$PKG_NAME"`
-
- "$SAGE_ROOT"/build/make/pipestatus \
- "sage-spkg $OPTINFO $OPTF $OPTS $OPTC '$PKG' 2>&1" \
- "(trap '' SIGINT; tee -a '$SAGE_ROOT/logs/install.log' '$SAGE_LOGS/$PKG_NAME.log')"
- sage-logger \
- "sage-spkg $INSTALL_OPTIONS '$PKG'" "$SAGE_LOGS/$PKG_NAME.log"
- # Do not try to install further packages if one failed
- if [ $? -ne 0 ]; then
- exit 1
@ -434,6 +486,12 @@ diff -up src/bin/sage.orig src/bin/sage
- exit 0
-}
-
-
-if [ "$1" = '-package' -o "$1" = "--package" ]; then
- shift
- exec sage-package $@
-fi
-
-if [ "$1" = '-optional' -o "$1" = "--optional" ]; then
- shift
- exec sage-list-packages optional $@
@ -454,26 +512,15 @@ diff -up src/bin/sage.orig src/bin/sage
- exec sage-list-packages installed $@
-fi
-
-if [ "$1" = '-i' ]; then
-if [ "$1" = '-p' ]; then
- shift
- # If there are no further arguments, simply list all installed
- # packages.
- # If there are no further arguments, display usage help.
- if [ $# -eq 0 ]; then
- exec sage-spkg
- fi
- install "$@"
-fi
-
-if [ "$1" = '-f' ]; then
- shift
- # If there are no further arguments, simply list all installed
- # packages.
- if [ $# -eq 0 ]; then
- exec sage-spkg
- fi
- install -f "$@"
-fi
-
-if [ "$1" = '-info' -o "$1" = '--info' ]; then
- shift
- for PKG in "$@"
@ -508,21 +555,29 @@ diff -up src/bin/sage.orig src/bin/sage
- exec sage-rsyncdist $2
-fi
-
-if [ "$1" = '-bdist' -o "$1" = "--bdist" ]; then
- maybe_sage_location
- shift
- exec sage-bdist "$@"
-fi
-
-if [ "$1" = "-docbuild" -o "$1" = "--docbuild" ]; then
- shift
- exec python "$SAGE_DOC/common/builder.py" "$@"
- exec python -m "sage_setup.docbuild" "$@"
-fi
-
if [ "$1" = '-gdb' -o "$1" = "--gdb" ]; then
-if [ "$1" = '-gdb' -o "$1" = "--gdb" ]; then
- shift
- sage_setup
- if [ "$SAGE_DEBUG" = "no" ]; then
- gdb -x "$SAGE_LOCAL/bin/sage-gdb-commands" \
- -args python "$SAGE_LOCAL/bin/sage-ipython" "$@" -i
- else
- cygdb "$SAGE_SRC/build" "$SAGE_SRC/sage" \
- -- -x "$SAGE_LOCAL/bin/sage-gdb-commands" \
- -args python "$SAGE_LOCAL/bin/sage-ipython" "$@" -i
- fi
- exit $?
-fi
-
if [ "$1" = '-preparse' -o "$1" = "--preparse" ]; then
shift
sage_setup
@@ -924,31 +587,11 @@ if [ "$1" = '-callgrind' -o "$1" = "--ca
exec sage-preparse "$@"
@@ -975,21 +593,10 @@ if [ "$1" = '-callgrind' -o "$1" = "--ca
exec sage-callgrind "$@"
fi
@ -540,24 +595,14 @@ diff -up src/bin/sage.orig src/bin/sage
- # Intentionally no "shift" here
- interactive_sage "$@"
-fi
-
-if [ "$1" = '-dev' -o "$1" = "--dev" ]; then
- shift
- exec sage-dev "$@"
-fi
-
if [ $# -ge 1 ]; then
- T=`echo "$1" | sed -e "s/.*\.//"`
- if [ "$T" = "spkg" ]; then
- install "$@"
- fi
SAGE_BANNER="no"
sage_setup
unset TERM # See Trac #12263
T=`echo "$1" | sed -e "s/.*\.//"`
if [ "$T" = "spkg" ]; then
diff -up src/bin/sage-runtests.orig src/bin/sage-runtests
--- src/bin/sage-runtests.orig 2015-11-07 11:53:13.991795336 -0200
+++ src/bin/sage-runtests 2015-11-07 11:53:18.458795507 -0200
@@ -55,10 +55,6 @@ if __name__ == "__main__":
--- src/bin/sage-runtests.orig 2016-08-08 13:12:45.999481909 -0400
+++ src/bin/sage-runtests 2016-08-08 13:13:01.713482511 -0400
@@ -56,10 +56,6 @@ if __name__ == "__main__":
help="run doctests using Valgrind's cachegrind tool. The log "
"files are named sage-cachegrind.PID and can be found in " +
os.path.join(os.environ["DOT_SAGE"], "valgrind"))
@ -569,8 +614,8 @@ diff -up src/bin/sage-runtests.orig src/bin/sage-runtests
parser.add_option("-f", "--failed", action="store_true", default=False,
help="doctest only those files that failed in the previous run")
diff -up src/bin/sage-valgrind.orig src/bin/sage-valgrind
--- src/bin/sage-valgrind.orig 2015-11-07 11:53:13.997795336 -0200
+++ src/bin/sage-valgrind 2015-11-07 11:53:18.458795507 -0200
--- src/bin/sage-valgrind.orig 2016-08-08 13:13:12.399482920 -0400
+++ src/bin/sage-valgrind 2016-08-08 13:13:37.233483871 -0400
@@ -1,16 +1,6 @@
#!/usr/bin/env bash
@ -585,7 +630,7 @@ diff -up src/bin/sage-valgrind.orig src/bin/sage-valgrind
-SUPP+=" --suppressions=$SAGE_EXTCODE/valgrind/sage-additional.supp"
-
-MEMCHECK_FLAGS="--leak-resolution=high --leak-check=full --num-callers=25 $SUPP"
+MEMCHECK_FLAGS="--leak-resolution=high --leak-check=full --num-callers=25"
+MEMCHECK_FLAGS="--leak-resolution=high --leak-check=full --num-callers=25 "
if [ "$SAGE_MEMCHECK_FLAGS" ]; then
echo "Overwriting memcheck flags with: $SAGE_MEMCHECK_FLAGS"